#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "hash.h"

/* create a hash table of given size */
HASH hash_create(unsigned int elems, unsigned int elemsize)
{
	HASH h = (HASH) malloc(sizeof(struct HASH_));

	if (!h) return NULL;

	h->elems = elems;
	h->elemsize = elemsize;

	h->data = malloc(elems * elemsize);
	if (!h->data) { free(h); return NULL; }

	memset(h->data, 0, elems * elemsize);

	return h;
}

unsigned int hash_default_hash(HASH h, char *key)
{
	int i, n = strlen(key);
	unsigned int idx = 0;

	for (i = 0; i < n; i++)
		idx = (idx << 5) + key[i];
	idx = idx % h->elems;

	return idx;
}

unsigned int yohoo_hash(HASH h, char *key)
{
	struct in_addr in;

	inet_aton(key, &in);
	return (unsigned int) in.s_addr;
}

void* hash_hash(HASH h, char *key)
{
	unsigned int idx = 0;

	if (!h) return NULL;
	if (!key) return NULL;

	idx = yohoo_hash(h, key);

	idx = idx % h->elems;

//	printf("[hash] key \"%s\" hashed to index %d\n", key, idx);

/*	if (h->data[idx])
	{
		printf("[hash] something already there\n");
	}

	else
	{
		h->data[idx] = (void *) malloc(h->elemsize);
		if (!h->data[idx]) return NULL;
	}
*/
	return (h->data + idx * h->elemsize);
}
