#include <net/ethernet.h>

char* mac_ntoa(char *buffer, unsigned char *addr);
char* hwtype_ntoa(short hwtype);
char* prot_ntoa(short prot);
void add_host(char *hostname, char *ip, char *mac, int state);

struct arp_payload
{
	unsigned char ar_sha[ETH_ALEN];
	unsigned char ar_sip[4];
	unsigned char ar_tha[ETH_ALEN];
	unsigned char ar_tip[4];
};

#define MAXBUF 80
#define MAXHOSTS 1021

struct host
{
	unsigned char name[MAXBUF];		/* DNS hostname */
	unsigned char group[MAXBUF];		/* workgroup */
	unsigned char ip[16];			/* dotted decimal IP */
	unsigned char mac[20];			/* MAC address */
	int alive;				/* is host alive? */
	int tstamp;				/* last time() when active */
	struct host *lastpeer;			/* who was last peer? */
};

